// How to compile :
// gcc -o bubblesort_seq bubblesort_seq.c
// How to excute :
// ./bubblesort_seq

#include <stdio.h>
#include <time.h>

int main() {
    int arr[] = {5, 2, 9, 1, 6};
    int arr2[] = {5, 2, 9, 1, 6};
    int n = sizeof(arr) / sizeof(arr[0]); // sizeof(arr) gives the size in octet of the array, while sizeof(arr[0]) gives the size of the first element in octet
    // printf("size of array : %ld and size of arr[0] : %ld \n", sizeof(arr), sizeof(arr[0]));
    int i, j, temp;
    int swapped;


    // Print the unsorted array
    printf("Unsorted array: \n");
    for (i = 0; i < n; i++) {
        printf("%d ", arr[i]);
    }
    printf("\n");

    printf("==========================================================\n");

    // Start measuring time
    clock_t start_time = clock();



    // Bubble Sort algorithm
    for (i = 0; i < n - 1; i++) {
        // Inner loop for comparing adjacent elements
        for (j = 0; j < n - i - 1; j++) {
            // If the current element is greater than the next element
            if (arr[j] > arr[j + 1]) {
                // Swap them
                temp = arr[j];
                arr[j] = arr[j + 1];
                arr[j + 1] = temp;
            }
        }
    }
    
    // End measuring time
    clock_t end_time = clock();

    // Print the sorted array
    printf("Sorted array by bubblesort: \n");
    for (i = 0; i < n; i++) {
        printf("%d ", arr[i]);
    }
    printf("\n");

    // Calculate and print the time taken
    double time_taken = ((double)(end_time - start_time)) / CLOCKS_PER_SEC;
    printf("Time taken for odd-even bubble sort : %f seconds\n", time_taken);

    printf("==========================================================\n");

    // Start measuring time
    clock_t start_time2 = clock();

    // Bubble Sort odd-even algorithm
    // We need to iterate n times to ensure the list is sorted
    for (i = 0; i < n; i++) {
        // Perform Bubble sort on odd indexed elements
        for (j = 1; j <= n - 2; j += 2) {
            if (arr2[j] > arr2[j + 1]) {
                temp = arr2[j];
                arr2[j] = arr2[j + 1];
                arr2[j + 1] = temp;
            }
        }

        // Perform Bubble sort on even indexed elements
        for (j = 0; j <= n - 2; j += 2) {
            if (arr2[j] > arr2[j + 1]) {
                temp = arr2[j];
                arr2[j] = arr2[j + 1];
                arr2[j + 1] = temp;
            }
        }
    }
    
    // End measuring time
    clock_t end_time2 = clock();

    // Print the sorted array
    printf("Sorted array by bubblesort odd-even: \n");
    for (i = 0; i < n; i++) {
        printf("%d ", arr2[i]);
    }
    printf("\n");

    // Calculate and print the time taken
    double time_taken2 = ((double)(end_time2 - start_time2)) / CLOCKS_PER_SEC;
    printf("Time taken for odd-even bubble sort : %f seconds\n", time_taken2);


    return 0;
}
