// How to compile :
// gcc -o maxvector_seq maxvector_seq.c
// How to excute :
// ./maxvector_seq

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define N 1000 // Define the size of the vector

int main() {
    int vector[N];
    int i, max;

    // Seed the random number generator
    srand(time(NULL));

    // Generate random values for the vector
    for (i = 0; i < N; i++) {
        vector[i] = rand() % 1000; // Random values between 0 and 999
    }

    // Print the generated vector
    printf("Generated vector: \n");
    for (i = 0; i < N; i++) {
        printf("%d ", vector[i]);
    }
    printf("\n");

    // Start measuring time
    clock_t start_time = clock();

    // Find the maximum value in the vector
    max = vector[0];
    for (i = 1; i < N; i++) {
        if (vector[i] > max) {
            max = vector[i];
        }
    }

    // End measuring time
    clock_t end_time = clock();


    // Print the maximum value
    printf("Maximum value in the vector: %d\n", max);

    // Calculate and print the time taken
    double time_taken = ((double)(end_time - start_time)) / CLOCKS_PER_SEC;
    printf("Time taken : %f seconds\n", time_taken);

    return 0;
}
