// How to compile :
// gcc -o prime_seq prime_seq.c
// How to excute :
// ./prime_seq

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <stdbool.h> // Include the header file for bool type

#define N 100

// 1 is not a prime number because it has only one divider, where the definition for a prime number is "only 2 dividers, itself and 1"

int main() {

    // Start measuring time
    clock_t start_time = clock();

    int num_primes = 0;
    for (int i = 2 ; i<N ;i++){
        bool is_prime = true ;
        for (int j=2 ; j<i ; j++){
            if (i%j == 0){
                is_prime = false ;
                break ;
            }
        }
        if (is_prime){
            printf(" %d ",i);
            num_primes++ ;
        }
    }
    printf("\n");

    // End measuring time
    clock_t end_time = clock();

    printf("Between 1 and %d, there is %d prime numbers\n",N,num_primes);

    // Calculate and print the time taken
    double time_taken = ((double)(end_time - start_time)) / CLOCKS_PER_SEC;
    printf("Time taken : %f seconds\n", time_taken);

    return 0;

}