// How to compile :
// gcc -o mat_seq mat_seq.c
// How to excute :
// ./mat_seq

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define n 100
#define m 100
#define l 100


int main() {

    // Initialisation for random numbers
    srand(time(NULL));

    // Start measuring time
    clock_t start_time = clock();

    // Allocating memory for A, matrix of size (m,n), B matrix of size (n,l) and C matrix of size (m,l)
    int** A = (int**)malloc(m * sizeof(int*));
    int** B = (int**)malloc(n * sizeof(int*));
    int** C = (int**)malloc(m * sizeof(int*));
    for (int i = 0; i < m; i++) {
        A[i] = (int*)malloc(n * sizeof(int));
        C[i] = (int*)malloc(l * sizeof(int));
    }
    for (int i = 0; i < n; i++) {
        B[i] = (int*)malloc(l * sizeof(int));
    }


    // Initialisation for A
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < n; j++) {
            A[i][j] = rand() % 100; // Générer un nombre aléatoire entre 0 et 99
        }
    }

    // Initialisation for B
    for (int i = 0; i < n; i++) {
        for (int j = 0; j < l; j++) {
            B[i][j] = rand() % 100; // Générer un nombre aléatoire entre 0 et 99
        }
    }


    // Initialisation of C to 0
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < l; j++) {
            C[i][j] = 0;
        }
    }

    

    // Product of matrices A and B to get C
    for (int i = 0; i < m; i++) {
        for (int j = 0; j < l; j++) {
            for (int k = 0; k < n; k++) {
                C[i][j] += A[i][k] * B[k][j];
            }
        }
    }

    // End measuring time
    clock_t end_time = clock();


    // // To show matrix A
    // for (int i = 0; i < m; i++) {
    //     for (int j = 0; j < n; j++) {
    //         printf("%d ", A[i][j]);
    //     }
    //     printf("\n");
    // }

    // Calculate and print the time taken
    double time_taken = ((double)(end_time - start_time)) / CLOCKS_PER_SEC;
    printf("Time taken : %f seconds\n", time_taken);


    // Free allocated memory
    for (int i = 0; i < m; i++) {
        free(A[i]);
        free(C[i]);
    }
    free(A);
    for (int i = 0; i < n; i++) {
        free(B[i]);
    }
    free(B);


    return 0;
}
