// How to compile :
// mpicc -o run load.c
// How to execute :
// mpirun -np <number_of_processes> ./run

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <mpi.h>

#define n 20


void load(int me, int size, int Np, int *iBeg, int *iEnd)
{
    int r = size % Np;
    if (me < r) {
        *iBeg = me * (size / Np + 1);
        *iEnd = *iBeg + (size / Np + 1) - 1;
    } else {
        *iBeg = r + me * (size / Np);
        *iEnd = *iBeg + (size / Np) - 1;
    }
}


int main(int argc, char *argv[]) {

    int me, Np;

    // Initialize MPI
    MPI_Init(&argc, &argv);
    MPI_Comm_rank(MPI_COMM_WORLD, &me);
    MPI_Comm_size(MPI_COMM_WORLD, &Np);

    int iBeg, iEnd;
    load(me, n, Np, &iBeg, &iEnd);

    printf("Thread number %d, iBeg = %d, iEnd = %d \n", me, iBeg, iEnd);


}    